=== debian/changelog ===
cpu-features (0.7.0-1) unstable; urgency=medium

  * New upstream version
  * Update Standards-Version to 4.6.1 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 17 Jun 2022 01:26:06 +0800
