=== debian/control ===
--- 
+++ 
@@ -1,21 +1,27 @@
 Source: cpu-features
 Section: libdevel
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Shengjing Zhu <zhsj@debian.org>
+Maintainer: Shengjing Zhu <zhsj@debian.org>
 Rules-Requires-Root: no
-Build-Depends: cmake, debhelper-compat (= 12), googletest
-Standards-Version: 4.5.1
+Build-Depends:
+ cmake,
+ debhelper-compat (= 13),
+ googletest,
+Standards-Version: 4.6.1
 Homepage: https://github.com/google/cpu_features
 Vcs-Git: https://salsa.debian.org/zhsj/cpu-features.git
 Vcs-Browser: https://salsa.debian.org/zhsj/cpu-features
 
 Package: libcpu-features-dev
 Architecture: amd64 arm64 armel armhf i386 mips64el mipsel powerpc ppc64 ppc64el x32
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Multi-Arch: same
-Breaks: libvolk2-dev (<< 2.4.1-2)
-Replaces: libvolk2-dev (<< 2.4.1-2)
+Breaks:
+ libvolk2-dev (<< 2.4.1-2),
+Replaces:
+ libvolk2-dev (<< 2.4.1-2),
 Description: cross platform C99 library to get cpu features
  Cross-platform C library to retrieve CPU features(such as available
  instructions) at runtime.
