=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
 https://github.com/google/cpu_features \
  refs/tags/v?@ANY_VERSION@ debian
