=== debian/changelog ===
cpu-features (0.9.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * add cmake4.patch (Closes: #1112810)

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 10 Nov 2025 11:06:37 +0100

cpu-features (0.9.0-1) unstable; urgency=medium

  * New upstream version
  * Update Standards-Version to 4.6.2 (no changes)
  * Update architecture
    + Drop mipsel, removed from Debian
    + Add loong64 riscv64 s390x
  * Build with -DBUILD_EXECUTABLE=OFF

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 06 Nov 2023 22:39:12 +0800
