=== debian/control ===
--- 
+++ 
@@ -7,13 +7,13 @@
  cmake,
  debhelper-compat (= 13),
  googletest,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/google/cpu_features
 Vcs-Git: https://salsa.debian.org/zhsj/cpu-features.git
 Vcs-Browser: https://salsa.debian.org/zhsj/cpu-features
 
 Package: libcpu-features-dev
-Architecture: amd64 arm64 armel armhf i386 mips64el mipsel powerpc ppc64 ppc64el x32
+Architecture: amd64 arm64 armel armhf i386 loong64 mips64el powerpc ppc64 ppc64el riscv64 s390x x32
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
